<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta http-equiv="X-UA-Compatible" content="ie=edge" />
    <title>Demo Places Autocomplete with Maps and Markers</title>
    <style>
      /* estilos por default para poder mostrar el mapa */
      #map {
        height: 100%;
      }

      html,
      body {
        height: 100%;
        margin: 0;
        padding: 0;
      }
    </style>
  </head>
  <body>
    <input type="text" name="place" size="50" id="autocomplete" />
    <div id="map"></div>
  </body>
  <!-- Importamos la librería de Maps JavaScript API -->
  <script
    type="text/javascript"
    src="https://maps.googleapis.com/maps/api/js?key=API_KEY&libraries=places"
  ></script>
  <script>
    let map,
      mapElement,
      mapOptions,
      autocomplete,
      autocompleteElement,
      autocompleteOptions,
      marker;

    // Buscamos en el DOM los elementos con <div></div> con id igual a "map" e <input/> con id "autocomplete". Estos elementos seran los que hagan el render de nuestro mapa e implementen las funciones de Autocomplete respectivamente
    mapElement = document.getElementById("map");
    autocompleteElement = document.getElementById("autocomplete");

    // Opciones con las que se va a desplegar el mapa
    mapOptions = {
      center: { lat: 19.4334232, lng: -99.17643329999999 },
      zoom: 17
    };

    // Opciones con las que se va a inicializar Autocomplete
    autocompleteOptions = { types: ["geocode"] };

    // Función para inicializar el mapa
    const initMap = () => {
      // Creamos una clase tipo "Map" que será el mapa de nuestro sitio
      map = new google.maps.Map(mapElement, mapOptions);
    };

    // Función para inicializar Autocomplete
    const initAutocomplete = () => {
      // Creamos una clase de tipo Autocomplete y utilizamos el elemento y las opciones previamente generadas
      autocomplete = new google.maps.places.Autocomplete(
        autocompleteElement,
        autocompleteOptions
      );
      // Se especifica la información sobre el lugar que queremos. Si no se especifica se trae toda la información disponible y se hace el cobro respectivo
      autocomplete.setFields(["geometry.location"]);
      // Se agrega un "Listener" para cuando el usuario haya encontrado el lugar que buscaba y quiera la información de éste
      autocomplete.addListener("place_changed", logPlace);
    };

    // Función de que manda a llamar en cuanto el usuario selecciona un lugar
    const logPlace = () => {
      // Se obtine la información del lugar y se almancena en una variable
      const place = autocomplete.getPlace();
      // Se obtienen los datos longitud y latitud del lugar mandando a llamar a las funciones respectivas del objeto "place" que declaramos en la línea anterior
      const placeLat = place.geometry.location.lat();
      const placeLng = place.geometry.location.lng();
      // Se almacenan los datos longitud y latitud del lugar en una variable para después ser utilizados al momento de mostrar el marcador
      const placePosition = { lat: placeLat, lng: placeLng };
      // Se usa la ubicación del lugar para centar el mapa en esa posición
      map.setCenter(placePosition);

      // Se crea una clase de tipo "Marker" que es el marcador que se va a mostrar en el mapa
      const marker = new google.maps.Marker({
        // Se especifica la posición del marcador con la ubicación que obtuvimos del lugar
        position: placePosition,
        // Especificamos que se va a desplegar en el mapa "map" que creamos previamente
        map: map
      });
    };

    // Mandamos a llamar las funciones para que se creen el mapa y el autocomplete
    initMap();
    initAutocomplete();
  </script>
</html>
